// GLSL 4.10
#version 410

#define FRAME_LAYERS 16
#define MAX_VERTICES 3

layout(triangles, invocations = FRAME_LAYERS) in;
layout(triangle_strip, max_vertices = MAX_VERTICES) out;

uniform mat4 modelViewProjectionMatrix[FRAME_LAYERS];

in Vertex {
    vec2 tex_coord;
} In[MAX_VERTICES];

out Vertex {
    vec2 tex_coord;
} Out;

void main () {
    gl_Layer = gl_InvocationID;

    for (int v = 0; v < gl_in.length(); v++) {
        gl_Position = modelViewProjectionMatrix[gl_InvocationID] * gl_in[v].gl_Position;

        gl_ViewportIndex = 1;

        Out.tex_coord = In[v].tex_coord;
        EmitVertex();
    }

    EndPrimitive();
}
